package kr.pe.nowonbun.calculater;

import java.util.ArrayList;
import java.util.Stack;


public class Calculator {
	private String[] operation1 = {"!"};
	private String[] operation2 = {"+","-","*","/","(",")","%","^","!" };
	private String[] wordoperation0 = {"pi","e"};
	private String[] wordoperation1 = {"sinh" ,"asin","cosh","acos","tanh","atan","sqrt",
								"exp","abs" ,"sin","cos", "tan" ,"log", "ceil", "floor","round"};
	private String[] wordoperation2 = { "pow"};
	private static Calculator instance = null;
	private Calculator(){}
	private  static Calculator getInstance(){
		if(instance == null){
			instance = new Calculator();
		}
		return instance;
	}
	public static Double Calculate(String data) 
			throws OperationFormatException, CalculateException, NullPointerException{
		return Calculator.getInstance().calc(data);
	}
	private Double calc(String data) 
			throws OperationFormatException, CalculateException, NullPointerException{
		data = data.replace(" ", "");
		Double ret = 0.0d;
		ArrayList<Object> tokenStack = makeTokens(data);
		tokenStack = convertPostOrder(tokenStack);
		Stack<Object> calcStack = new Stack<Object>();
		for(Object s : tokenStack) {
            calcStack.push(s);
            calcStack = calcPostOrder(calcStack);
        }
		if(calcStack.size() == 1){
			ret = (Double)calcStack.pop();
		}else{
			throw new CalculateException();
		}
		return ret;
	}
	private Stack<Object> calcPostOrder(Stack<Object> calcStack) 
			throws CalculateException,NullPointerException {
        if(calcStack.lastElement().getClass().equals(Double.class)) {
            return calcStack;
        }
        Double op1 = null;
        Double op2 = null;
        String opcode = null;
        if(calcStack.size() >= 2) {
            opcode = (String)calcStack.pop();
            op1 = (Double)calcStack.pop();
            if(!opCodeCheck(opcode)){
            	op2 = (Double)calcStack.pop();
            }
            double result = calculateByOpCode(op1, op2, opcode);
            calcStack.push(result);
        }
        return calcStack;
    }
	private boolean opCodeCheck(String opcode){
		for(String c : wordoperation1){
			if(c.equals(opcode)){
				return true;
			}
		}
		for(String c : operation1){
			if(c.equals(opcode)){
				return true;
			}
		}
		return false;
	}
	private double calculateByOpCode(Double op1, Double op2, String opcode) 
			throws CalculateException,NullPointerException{
		if(op1 == null)throw new NullPointerException("Op1 null Error");
		if(opcode == null)throw new NullPointerException("OPCode null Error");
        double result = 0.0;
        if("+".equals(opcode)) {
            result =  op1 + op2;
        } else if("-".equals(opcode)) {
            result =  op1 - op2;
        } else if("*".equals(opcode)) {
            result =  op1 * op2;
        } else if("/".equals(opcode)) {
            result =  op1 / op2;
        } else if("^".equals(opcode)){
        	result =  Math.pow(op2,op1);
        } else if("%".equals(opcode)){
           	result =  op2 % op1;
        } else if("!".equals(opcode)){
        	result = Factorial(op1);
        } else if("sin".equals(opcode)){
        	return Math.sin(op1);
        } else if("sinh".equals(opcode)){
        	return Math.sinh(op1);
        } else if("asin".equals(opcode)){
        	return Math.asin(op1);
        } else if("cos".equals(opcode)){
        	return Math.cos(op1);
        } else if("cosh".equals(opcode)){
        	return Math.cosh(op1);
        } else if("acos".equals(opcode)){
        	return Math.acos(op1);
        } else if("tan".equals(opcode)){
        	return Math.tan(op1);
        } else if("tanh".equals(opcode)){
        	return Math.tanh(op1);
        } else if("atan".equals(opcode)){
        	return Math.atan(op1);
        } else if("atan".equals(opcode)){
        	return Math.sqrt(op1);
        } else if("sqrt".equals(opcode)){
        	return Math.sqrt(op1);
        } else if("exp".equals(opcode)){
        	return Math.exp(op1);
        } else if("abs".equals(opcode)){
        	return Math.abs(op1);
        } else if("log".equals(opcode)){
        	return Math.log(op1);
        } else if("pow".equals(opcode)){
        	result = Math.pow(op2,op1);
        } else if("ceil".equals(opcode)){
        	return Math.ceil(op1);
        } else if("floor".equals(opcode)) {
        	return Math.floor(op1);
        } else if("round".equals(opcode)) {
        	return Math.round(op1);
        } 
        return result;
    }
	private Double Factorial(double input) throws CalculateException{
		double ans = 1.0d;
		if (input > 1){
			for (double i = input; i > 1; i--){
				ans *= i;
			}
		}else if (input < 0){
			throw new CalculateException("Factorial parameter Error");
		}
		if (ans == 0) throw new CalculateException("Factorial calculate result is 0 Error");
		return ans;
	}
	private ArrayList<Object> convertPostOrder(ArrayList<Object> tokenStack) 
			throws OperationFormatException{
		ArrayList<Object> postOrderList = new ArrayList<Object>();
		Stack<String> exprStack = new Stack<String>();
		Stack<String> wordStack = new Stack<String>();
		for(Object token : tokenStack) {
			if(token.getClass().equals(Double.class)){
				postOrderList.add(token);
			}else{
				postOrderList = exprAppend(token.toString(),exprStack,wordStack,postOrderList);
			}
		}
		String item = null;
        while(!exprStack.isEmpty()) {
            item = exprStack.pop();
            postOrderList.add(item);
        }
		return postOrderList;
	}
	private ArrayList<Object> exprAppend(String token,Stack<String> exprStack,
			Stack<String> wordStack,ArrayList<Object> postOrderList) 
			throws OperationFormatException{

		if(isWordOperation(token) > 0){
			if(ConverterWordResult(token) > 0.0d){
				postOrderList.add(ConverterWordResult(token));
			}else{
				wordStack.push(token);
			}
		}else if("(".equals(token)) {
            exprStack.push(token);
        }else if(")".equals(token)) {
            String opcode = null;
            while(true) {
            	if(wordStack.size() > 0){
            		opcode = exprStack.pop();
            		if("(".equals(opcode)){
            			opcode = wordStack.pop();
            			postOrderList.add(opcode);
            			break;
            		}else{
            			postOrderList.add(opcode);
            		}
            	}else{
            		if(exprStack.size() > 0){
	                    opcode = exprStack.pop();
	                    if("(".equals(opcode)) {
	                        break;
	                    }
	                    postOrderList.add(opcode);
            		}else{
            			break;
            		}
            	}
            }
        }else if(",".equals(token)){
        	if(wordStack.size() > 0){
        		String opcode = null;
        		while(true){
        			if(exprStack.size() > 0){
        				if("(".equals(exprStack.lastElement())) {
		                    break;
		                }
	        			opcode = exprStack.pop();
		                postOrderList.add(opcode);
        			}else{
        				break;
        			}
        		}
        	}else{
        		throw new OperationFormatException();
        	}
        }else if(isOperation(token)) {
            String opcode = null;
            while(true) {
                if(exprStack.isEmpty()) {
                    exprStack.push(token);
                    break;
                }
                opcode = exprStack.pop();
                if(exprOrder(opcode) > exprOrder(token)) {
                    postOrderList.add(opcode);
                } else {
                    exprStack.push(opcode);
                    exprStack.push(token);
                    break;
                }
            }
        }
		return postOrderList;
    }
	private ArrayList<Object> makeTokens(String s) throws OperationFormatException{
		ArrayList<Object> tokenStack = new ArrayList<Object>();
		StringBuffer tokenBuf = new StringBuffer();
        int argSize = s.length();
        String token = null;
        for(int i = 0; i < argSize; i++) {
            token = s.substring(i, i+1);
            if(!isOperation(token)) {
                tokenBuf.append(token);
                if(i == argSize - 1) {
                	Double su = Double.valueOf(tokenBuf.toString());
                    tokenStack.add(su);
                }
            }else{
                if(tokenBuf.length() > 0) {
                	Double su = Double.valueOf(tokenBuf.toString());
                    tokenStack.add(su);
                    tokenBuf = new StringBuffer();
                }
                int nWord = isWordOperation(s, i);
                if(nWord > 0){
                	tokenStack.add(s.substring(i, i+nWord));
                	i += (nWord-1);
                }else{
                	tokenStack.add(token);
                }
            }
        }
		return tokenStack;
	}

	private boolean isWord(String s,int index,String checkstr) 
			throws NullPointerException{
		if(s == null) throw new NullPointerException();
		if(checkstr == null) throw new NullPointerException();
		if(s.length() >= index + checkstr.length() && 
				checkstr.equals(s.substring(index,index+checkstr.length()))){
			return true;
		}else{
			return false;
		}
	}
	private int isWordOperation(String s) throws NullPointerException{
		return isWordOperation(s,0);
	}
	private int isWordOperation(String s,int index) throws NullPointerException{
		for(int i=0;i<wordoperation2.length;i++){
			if(isWord(s.toLowerCase(),index,wordoperation2[i])){
				return wordoperation2[i].length();
			}
		}
		for(int i=0;i<wordoperation1.length;i++){
			if(isWord(s.toLowerCase(),index,wordoperation1[i])){
				return wordoperation1[i].length();
			}
		}
		for(int i=0;i<wordoperation0.length;i++){
			if(isWord(s.toLowerCase(),index,wordoperation0[i])){
				return wordoperation0[i].length();
			}
		}
		return 0;
	}
	private double ConverterWordResult(String s) throws NullPointerException{
		for(int i=0;i<wordoperation0.length;i++){
			if(isWord(s.toLowerCase(),0,wordoperation0[i])){
				if("pi".equals(s.toLowerCase())){
					return Math.PI;
				}else if("e".equals(s.toLowerCase())){
					return Math.E;
				}
			}
		}
		return 0.0d;
	}
	private boolean isOperation(String s) 
			throws NullPointerException,OperationFormatException {
		if(s == null) throw new NullPointerException();
		if(s.length() != 1)	throw new OperationFormatException("Operation Format Error");
		if((s.getBytes()[0] >= 48 && s.getBytes()[0] <= 57) || s.getBytes()[0] == 46){
			return false;
		}else {
			return true;
		}
    }
	private int exprOrder(String s) throws NullPointerException{
		if(s == null) throw new NullPointerException();
        int order = -1;
        if("-".equals(s) || "+".equals(s)) {
            order = 0;
        } else if("*".equals(s) || "/".equals(s) ||  "%".equals(s)) {
            order = 1;
        } else if("^".equals(s) ||  "!".equals(s)){
        	order = 2;
        }
        return order;
    }
}
